{"openapi":"3.1.0","info":{"contact":{"email":"hi@hedia.com","name":"Hedia ApS","url":"https://hedia.com"},"termsOfService":"https://www.hedia.com/terms-and-conditions","title":"License Management API","version":"1.0.0"},"servers":[{"url":"https://licensing.hedia.com/management/api/v1"}],"security":[{"app":[]}],"tags":[{"name":"Countries","description":"Country management.","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations#countries","description":"Documentation"}},{"name":"Customers","description":"Customer management.","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations#customers","description":"Documentation"}},{"name":"Licenses","description":"License management.","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations#licenses","description":"Documentation"}},{"name":"Permissions","description":"Permission management.","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations#permissions","description":"Documentation"}},{"name":"Products","description":"Product management.","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations#products","description":"Documentation"}}],"paths":{"/countries":{"get":{"summary":"List Countries","operationId":"listCountries","description":"List countries.","parameters":[{"$ref":"#/components/parameters/SkipQueryParameter"},{"$ref":"#/components/parameters/LimitQueryParameter"}],"responses":{"200":{"description":"OK for listCountries","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CountryArray"}}}},"400":{"description":"Bad Request for listCountries","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InvalidRequestParameterProblem"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Countries"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/listCountries","description":"Documentation"}}},"/customers":{"get":{"summary":"List Customers","operationId":"listCustomers","description":"List customers.","parameters":[{"$ref":"#/components/parameters/CustomerCodeQueryParameter"}],"responses":{"200":{"description":"OK for listCustomers","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArray"}}}},"400":{"description":"Bad Request for listCustomers","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InvalidRequestParameterProblem"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Customers"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/listCustomers","description":"Documentation"}},"post":{"summary":"Create Customer","operationId":"createCustomer","description":"Create a customer.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"account":{"oneOf":[{"$ref":"#/components/schemas/AccountId"},{"$ref":"#/components/schemas/AccountCode"}]},"country":{"oneOf":[{"$ref":"#/components/schemas/CountryId"},{"$ref":"#/components/schemas/CountryCode"}]},"name":{"$ref":"#/components/schemas/CustomerName"},"reference":{"$ref":"#/components/schemas/CustomerReference"},"note":{"$ref":"#/components/schemas/CustomerNote"},"metadata":{"$ref":"#/components/schemas/Metadata"}},"required":["account","country","name"]}}}},"responses":{"201":{"description":"Created for createCustomer","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Customer"}}}},"400":{"description":"Bad Request for createCustomer","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InvalidRequestBodyProblem"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Customers"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/createCustomer","description":"Documentation"}}},"/licenses":{"get":{"summary":"List Licenses","operationId":"listLicenses","description":"List licenses.","parameters":[{"$ref":"#/components/parameters/CustomerIdQueryParameter"}],"responses":{"200":{"description":"OK for listLicenses","content":{"application/json":{"schema":{"$ref":"#/components/schemas/LicenseArray"}}}},"400":{"description":"Bad Request for listCustomers","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InvalidRequestParameterProblem"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Licenses"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/listLicenses","description":"Documentation"}},"post":{"summary":"Create License","operationId":"createLicense","description":"Create a license.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"type":{"$ref":"#/components/schemas/LicenseType"},"customer":{"anyOf":[{"$ref":"#/components/schemas/CustomerCode"},{"$ref":"#/components/schemas/CustomerId"}]},"product":{"anyOf":[{"$ref":"#/components/schemas/ProductCode"},{"$ref":"#/components/schemas/ProductId"}]},"user":{"anyOf":[{"$ref":"#/components/schemas/UserCode"},{"$ref":"#/components/schemas/UserId"}]},"startDate":{"$ref":"#/components/schemas/LicenseStartDate"},"endDate":{"$ref":"#/components/schemas/LicenseEndDate"},"duration":{"$ref":"#/components/schemas/Duration"},"note":{"$ref":"#/components/schemas/LicenseNote"},"metadata":{"$ref":"#/components/schemas/Metadata"}},"required":["type","customer","product"]}}}},"responses":{"201":{"description":"Created for createLicense","content":{"application/json":{"schema":{"$ref":"#/components/schemas/License"}}}},"400":{"description":"Bad Request for createLicense","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InvalidRequestBodyProblem"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Licenses"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/createLicense","description":"Documentation"}}},"/licenses/{licenseId}":{"parameters":[{"$ref":"#/components/parameters/LicenseIdPathParameter"}],"delete":{"summary":"Delete License","operationId":"deleteLicense","description":"Delete a license.","responses":{"204":{"$ref":"#/components/responses/NoContent"},"400":{"description":"Bad Request for deleteLicense","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestDeleteLicense"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Licenses"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/deleteLicense","description":"Documentation"}},"patch":{"summary":"Update License","operationId":"updateLicense","description":"Update a license.","requestBody":{"required":true,"content":{"application/json":{"schema":{"properties":{"type":{"description":"You can only update the license type if the license is not activated.","$ref":"#/components/schemas/LicenseType"},"userId":{"$ref":"#/components/schemas/UserId"},"startDate":{"$ref":"#/components/schemas/LicenseStartDate"},"endDate":{"$ref":"#/components/schemas/LicenseEndDate"},"duration":{"description":"How long the license should be valid for when activated. You can only update the duration if the license is not yet activated.","$ref":"#/components/schemas/Duration"},"note":{"$ref":"#/components/schemas/LicenseNote"},"metadata":{"$ref":"#/components/schemas/Metadata"}},"required":[]}}}},"responses":{"200":{"description":"OK for updateLicense","content":{"application/json":{"schema":{"$ref":"#/components/schemas/License"}}}},"400":{"description":"Bad Request for updateLicense","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/BadRequestUpdateLicense"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Licenses"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/updateLicense","description":"Documentation"}}},"/permissions":{"get":{"summary":"List Permissions","operationId":"listPermissions","description":"List permissions.","responses":{"200":{"description":"OK for listPermissions","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionArray"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Permissions"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/listPermissions","description":"Documentation"}}},"/products":{"get":{"summary":"List Products","operationId":"listProducts","description":"List products.","parameters":[{"$ref":"#/components/parameters/ProductCodeQueryParameter"}],"responses":{"200":{"description":"OK for listProducts","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductArray"}}}},"400":{"description":"Bad Request for listCustomers","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InvalidRequestParameterProblem"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"499":{"$ref":"#/components/responses/SignalAborted"},"default":{"$ref":"#/components/responses/InternalServerError"}},"tags":["Products"],"externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/operations/listProducts","description":"Documentation"}}}},"components":{"securitySchemes":{"app":{"description":"An App Bearer JSON Web Token.","type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Skip":{"title":"Skip","type":"number","minimum":0,"examples":[0,10],"$id":"./components/schemas/Skip","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Skip","description":"Documentation"}},"Limit":{"title":"Limit","type":"number","minimum":1,"maximum":100,"examples":[10],"$id":"./components/schemas/Limit","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Limit","description":"Documentation"}},"ProblemDetails":{"title":"Problem Details","description":"A problem details object provides additional information about a problem that occurred during an API request.","type":"object","properties":{"type":{"type":"string","description":"A URI reference that identifies the problem type.","examples":["/problems/unauthorized","about:blank"]},"title":{"type":"string","description":"A short, human-readable summary of the problem type.","examples":["Unauthorized"]},"status":{"type":"number","description":"The HTTP status code generated by the origin server for this occurrence of the problem.","examples":[401]},"detail":{"type":"string","description":"A human-readable explanation specific to this occurrence of the problem.","examples":["You must authenticate and provide the necessary permissions to access this resource. Please check your credentials or token."]}},"required":["type"],"$id":"./components/schemas/ProblemDetails","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/ProblemDetails","description":"Documentation"}},"InternalServerErrorProblem":{"title":"Internal Server Error Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/internal-server-error"},"title":{"type":"string"},"status":{"type":"number","const":500},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/InternalServerErrorProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/InternalServerErrorProblem","description":"Documentation"}},"CountryId":{"title":"Country ID","type":"string","format":"uuid","examples":["71191595-7dbd-400f-8798-dbcd8f0e6170"],"$id":"./components/schemas/CountryId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CountryId","description":"Documentation"}},"CountryCode":{"title":"Country Code","description":"ISO 3166-1 alpha-2 country code","type":"string","pattern":"[A-Z]{2}","examples":["DK","GB"],"minLength":2,"maxLength":2,"$id":"./components/schemas/CountryCode","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CountryCode","description":"Documentation"}},"CountryName":{"title":"Country Name","type":"string","examples":["Denmark","United Kingdom"],"$id":"./components/schemas/CountryName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CountryName","description":"Documentation"}},"Country":{"title":"Country","type":"object","properties":{"id":{"$ref":"#/components/schemas/CountryId"},"code":{"$ref":"#/components/schemas/CountryCode"},"name":{"$ref":"#/components/schemas/CountryName"}},"required":["id","code","name"],"additionalProperties":false,"$id":"./components/schemas/Country","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Country","description":"Documentation"}},"CountryArray":{"title":"Country Array","type":"array","items":{"$ref":"#/components/schemas/Country"},"$id":"./components/schemas/CountryArray","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CountryArray","description":"Documentation"}},"InvalidRequestParameterProblem":{"title":"Invalid Request Parameter Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/invalid-request-parameter"},"title":{"type":"string"},"status":{"type":"number","const":400},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/InvalidRequestParameterProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/InvalidRequestParameterProblem","description":"Documentation"}},"UnauthorizedProblem":{"title":"Unauthorized Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/unauthorized"},"title":{"type":"string"},"status":{"type":"number","const":401},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/UnauthorizedProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/UnauthorizedProblem","description":"Documentation"}},"OperationNotFoundProblem":{"title":"Operation Not Found Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/operation-not-found"},"title":{"type":"string"},"status":{"type":"number","const":404},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/OperationNotFoundProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/OperationNotFoundProblem","description":"Documentation"}},"SignalAbortedProblem":{"title":"Signal Aborted Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/signal-aborted"},"title":{"type":"string"},"status":{"type":"number","const":499},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/SignalAbortedProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/SignalAbortedProblem","description":"Documentation"}},"CustomerCode":{"title":"Customer Code","type":"string","maxLength":16,"examples":["C1234567"],"$id":"./components/schemas/CustomerCode","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CustomerCode","description":"Documentation"}},"CustomerId":{"title":"Customer ID","type":"string","format":"uuid","examples":["d15cf714-0975-4adf-a15f-26d0db611b25"],"$id":"./components/schemas/CustomerId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CustomerId","description":"Documentation"}},"AccountId":{"title":"Account ID","type":"string","format":"uuid","examples":["d15cf714-0975-4adf-a15f-26d0db611b25"],"$id":"./components/schemas/AccountId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/AccountId","description":"Documentation"}},"AccountCode":{"title":"Account Code","type":"string","maxLength":16,"examples":["A1234567"],"$id":"./components/schemas/AccountCode","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/AccountCode","description":"Documentation"}},"AccountName":{"title":"Account Name","type":"string","maxLength":64,"examples":["Glooko"],"$id":"./components/schemas/AccountName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/AccountName","description":"Documentation"}},"DateTime":{"title":"Date Time","type":"string","format":"date-time","examples":["2025-01-01T00:00:00.000Z"],"$id":"./components/schemas/DateTime","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/DateTime","description":"Documentation"}},"SecurityPrincipalId":{"title":"Security Principal ID","type":"string","format":"uuid","$id":"./components/schemas/SecurityPrincipalId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/SecurityPrincipalId","description":"Documentation"}},"SecurityPrincipalName":{"title":"Name","type":"string","$id":"./components/schemas/SecurityPrincipalName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/SecurityPrincipalName","description":"Documentation"}},"SecurityPrincipalType":{"title":"Security Principal Type","type":"string","enum":["app","service","user"],"$id":"./components/schemas/SecurityPrincipalType","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/SecurityPrincipalType","description":"Documentation"}},"SecurityPrincipal":{"title":"Security Principal","type":"object","properties":{"id":{"$ref":"#/components/schemas/SecurityPrincipalId"},"name":{"$ref":"#/components/schemas/SecurityPrincipalName"},"type":{"$ref":"#/components/schemas/SecurityPrincipalType"}},"required":["id","type"],"$id":"./components/schemas/SecurityPrincipal","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/SecurityPrincipal","description":"Documentation"}},"Created":{"title":"Created","type":"object","properties":{"at":{"$ref":"#/components/schemas/DateTime"},"by":{"$ref":"#/components/schemas/SecurityPrincipal"}},"required":["at","by"],"$id":"./components/schemas/Created","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Created","description":"Documentation"}},"Updated":{"title":"Updated","type":"object","properties":{"at":{"$ref":"#/components/schemas/DateTime"},"by":{"$ref":"#/components/schemas/SecurityPrincipal"}},"required":["at","by"],"$id":"./components/schemas/Updated","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Updated","description":"Documentation"}},"Account":{"title":"Account","type":"object","properties":{"id":{"$ref":"#/components/schemas/AccountId"},"code":{"$ref":"#/components/schemas/AccountCode"},"name":{"$ref":"#/components/schemas/AccountName"},"created":{"$ref":"#/components/schemas/Created"},"updated":{"$ref":"#/components/schemas/Updated"}},"required":["id","code","name","created"],"additionalProperties":false,"$id":"./components/schemas/Account","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Account","description":"Documentation"}},"CustomerName":{"title":"Customer Name","type":"string","maxLength":64,"examples":["Hedia ApS"],"$id":"./components/schemas/CustomerName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CustomerName","description":"Documentation"}},"CustomerReference":{"title":"Customer Reference","type":"string","examples":["ABC123456"],"maxLength":64,"$id":"./components/schemas/CustomerReference","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CustomerReference","description":"Documentation"}},"CustomerNote":{"title":"Customer Note","type":"string","examples":["Made with love"],"maxLength":512,"$id":"./components/schemas/CustomerNote","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CustomerNote","description":"Documentation"}},"Metadata":{"title":"Metadata","type":"object","additionalProperties":{"oneOf":[{"type":"string","maxLength":512},{"type":"number"},{"type":"boolean"}]},"maxProperties":64,"default":{},"$id":"./components/schemas/Metadata","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Metadata","description":"Documentation"}},"Customer":{"title":"Customer","type":"object","properties":{"id":{"$ref":"#/components/schemas/CustomerId"},"account":{"$ref":"#/components/schemas/Account"},"country":{"$ref":"#/components/schemas/Country"},"code":{"$ref":"#/components/schemas/CustomerCode"},"name":{"$ref":"#/components/schemas/CustomerName"},"reference":{"$ref":"#/components/schemas/CustomerReference"},"note":{"$ref":"#/components/schemas/CustomerNote"},"metadata":{"$ref":"#/components/schemas/Metadata"},"created":{"$ref":"#/components/schemas/Created"},"updated":{"$ref":"#/components/schemas/Updated"}},"required":["id","account","country","code","name","metadata","created"],"additionalProperties":false,"$id":"./components/schemas/Customer","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Customer","description":"Documentation"}},"CustomerArray":{"title":"Customer Array","type":"array","items":{"$ref":"#/components/schemas/Customer"},"$id":"./components/schemas/CustomerArray","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/CustomerArray","description":"Documentation"}},"InvalidRequestBodyProblem":{"title":"Invalid Request Body Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/invalid-request-body"},"title":{"type":"string"},"status":{"type":"number","const":400},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/InvalidRequestBodyProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/InvalidRequestBodyProblem","description":"Documentation"}},"UnsupportedMediaTypeProblem":{"title":"Unsupported Media Type Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/unsupported-media-type"},"title":{"type":"string"},"status":{"type":"number","const":415},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/UnsupportedMediaTypeProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/UnsupportedMediaTypeProblem","description":"Documentation"}},"Html":{"title":"Html","description":"The HTML is the HTML content of the page.","type":"string","$id":"./components/schemas/Html","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Html","description":"Documentation"}},"LicenseId":{"title":"License ID","type":"string","format":"uuid","examples":["4ea7bcbe-552c-4068-9e0f-a307ec5d798d"],"$id":"./components/schemas/LicenseId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseId","description":"Documentation"}},"ProductId":{"title":"Product ID","type":"string","format":"uuid","examples":["5f50e769-7c0e-4839-a6a7-d3a07474dc28"],"$id":"./components/schemas/ProductId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/ProductId","description":"Documentation"}},"ProductCode":{"title":"Product Code","type":"string","pattern":"^[A-Z-0-9]{3,8}$","examples":["HDA"],"$id":"./components/schemas/ProductCode","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/ProductCode","description":"Documentation"}},"ProductName":{"title":"Product Name","type":"string","maxLength":64,"examples":["Hedia Diabetes Assistant"],"$id":"./components/schemas/ProductName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/ProductName","description":"Documentation"}},"Date":{"title":"Date","type":"string","format":"date","examples":["2025-01-01"],"$id":"./components/schemas/Date","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Date","description":"Documentation"}},"Product":{"title":"Product","type":"object","properties":{"id":{"$ref":"#/components/schemas/ProductId"},"code":{"$ref":"#/components/schemas/ProductCode"},"name":{"$ref":"#/components/schemas/ProductName"},"createdAt":{"$ref":"#/components/schemas/Date"},"updatedAt":{"$ref":"#/components/schemas/Date"}},"required":["id","code","name","createdAt"],"additionalProperties":false,"$id":"./components/schemas/Product","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Product","description":"Documentation"}},"UserId":{"title":"User ID","type":"string","format":"uuid","examples":["3f483b7c-ae82-44ac-94f1-0820861fef29"],"$id":"./components/schemas/UserId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/UserId","description":"Documentation"}},"UserCode":{"title":"User Code","type":"string","pattern":"^U[a-zA-Z0-9]{7}$","examples":["UABC1234"],"$id":"./components/schemas/UserCode","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/UserCode","description":"Documentation"}},"UserName":{"title":"User Name","type":"string","examples":["John Doe"],"$id":"./components/schemas/UserName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/UserName","description":"Documentation"}},"User":{"title":"User","type":"object","properties":{"id":{"$ref":"#/components/schemas/UserId"},"code":{"$ref":"#/components/schemas/UserCode"},"name":{"$ref":"#/components/schemas/UserName"},"createdAt":{"$ref":"#/components/schemas/Date"},"updatedAt":{"$ref":"#/components/schemas/Date"}},"required":["id","code","createdAt"],"additionalProperties":false,"$id":"./components/schemas/User","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/User","description":"Documentation"}},"LicenseKey":{"title":"License Key","type":"string","pattern":"[A-Z0-9]{4}-[A-Z0-9]{4}-[A-Z0-9]{4}","examples":["R4A8-Y6O5-F4E2"],"$id":"./components/schemas/LicenseKey","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseKey","description":"Documentation"}},"LicenseType":{"title":"License Type","type":"string","enum":["perpetual","subscription","time-limited"],"examples":["perpetual"],"$id":"./components/schemas/LicenseType","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseType","description":"Documentation"}},"LicenseStatus":{"title":"License Status","type":"string","enum":["expired","upcoming","active","inactive"],"examples":["active"],"$id":"./components/schemas/LicenseStatus","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseStatus","description":"Documentation"}},"LicenseStartDate":{"title":"License Start Date","description":"When issuing a license, you can set a start date for it. Adding a start date to a license will not allow license activations until that date. The start date must be today or in the future, and it can not be after the end date.","type":"string","format":"date","examples":["2025-01-01"],"$id":"./components/schemas/LicenseStartDate","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseStartDate","description":"Documentation"}},"LicenseEndDate":{"title":"License End Date","description":"The date when the license ends. If specified, it must be today or in the future, and it can not be before the start date.","type":"string","format":"date","examples":["2025-07-01"],"$id":"./components/schemas/LicenseEndDate","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseEndDate","description":"Documentation"}},"Duration":{"title":"License Duration","description":"How long the license will stay active after activation.","type":"string","enum":["P1M","P3M","P6M","P12M"],"examples":["P1M"],"$id":"./components/schemas/Duration","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Duration","description":"Documentation"}},"LicenseIsActive":{"title":"License Is Active","type":"boolean","$id":"./components/schemas/LicenseIsActive","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseIsActive","description":"Documentation"}},"LicenseNote":{"title":"License Note","type":"string","maxLength":512,"$id":"./components/schemas/LicenseNote","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseNote","description":"Documentation"}},"License":{"title":"License","type":"object","properties":{"id":{"$ref":"#/components/schemas/LicenseId"},"customer":{"$ref":"#/components/schemas/Customer"},"product":{"$ref":"#/components/schemas/Product"},"user":{"$ref":"#/components/schemas/User"},"key":{"$ref":"#/components/schemas/LicenseKey"},"type":{"$ref":"#/components/schemas/LicenseType"},"status":{"$ref":"#/components/schemas/LicenseStatus"},"startDate":{"$ref":"#/components/schemas/LicenseStartDate"},"endDate":{"$ref":"#/components/schemas/LicenseEndDate"},"duration":{"$ref":"#/components/schemas/Duration"},"is_active":{"$ref":"#/components/schemas/LicenseIsActive"},"note":{"$ref":"#/components/schemas/LicenseNote"},"metadata":{"$ref":"#/components/schemas/Metadata"},"created":{"$ref":"#/components/schemas/Created"},"updated":{"$ref":"#/components/schemas/Updated"}},"required":["id","customer","product","key","type","status","metadata","created"],"additionalProperties":false,"$id":"./components/schemas/License","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/License","description":"Documentation"}},"LicenseArray":{"title":"License Array","type":"array","items":{"$ref":"#/components/schemas/License"},"$id":"./components/schemas/LicenseArray","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseArray","description":"Documentation"}},"LicenseNotFoundProblem":{"title":"License Not Found Problem","type":"object","allOf":[{"$ref":"#/components/schemas/ProblemDetails"}],"properties":{"type":{"type":"string","const":"/problems/license-not-found"},"title":{"type":"string"},"status":{"type":"number","const":400},"detail":{"type":"string"}},"required":["type","title","status"],"$id":"./components/schemas/LicenseNotFoundProblem","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/LicenseNotFoundProblem","description":"Documentation"}},"BadRequestDeleteLicense":{"title":"Bad Request for deleteLicense","oneOf":[{"$ref":"#/components/schemas/LicenseNotFoundProblem"},{"$ref":"#/components/schemas/InvalidRequestParameterProblem"}],"$id":"./components/schemas/BadRequestDeleteLicense","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/BadRequestDeleteLicense","description":"Documentation"}},"BadRequestUpdateLicense":{"title":"Bad Request for listProducts","oneOf":[{"$ref":"#/components/schemas/LicenseNotFoundProblem"},{"$ref":"#/components/schemas/InvalidRequestBodyProblem"}],"$id":"./components/schemas/BadRequestUpdateLicense","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/BadRequestUpdateLicense","description":"Documentation"}},"PermissionId":{"title":"Permission ID","type":"string","format":"uuid","examples":["70c88e30-6fff-4498-a008-8b6a24cf009c"],"$id":"./components/schemas/PermissionId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/PermissionId","description":"Documentation"}},"PermissionAction":{"title":"Permission Action","description":"The action property grant access to different endpoints.","type":"string","enum":["read","write"],"$id":"./components/schemas/PermissionAction","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/PermissionAction","description":"Documentation"}},"PermissionScope":{"title":"Permission Scope","description":"The scope property grant access to a specific set of data.","type":"string","enum":["licenses","customers"],"$id":"./components/schemas/PermissionScope","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/PermissionScope","description":"Documentation"}},"AppId":{"title":"App ID","type":"string","format":"uuid","examples":["d15cf714-0975-4adf-a15f-26d0db611b25"],"$id":"./components/schemas/AppId","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/AppId","description":"Documentation"}},"AppName":{"title":"App Name","description":"The unique name of the app using only lowercase letters, numbers and hyphens.","type":"string","pattern":"^[a-z0-9-]+$","minLength":1,"maxLength":256,"example":"hda","$id":"./components/schemas/AppName","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/AppName","description":"Documentation"}},"App":{"title":"App","type":"object","properties":{"id":{"$ref":"#/components/schemas/AppId"},"name":{"$ref":"#/components/schemas/AppName"}},"required":["id","name"],"additionalProperties":false,"$id":"./components/schemas/App","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/App","description":"Documentation"}},"Permission":{"title":"Permission","type":"object","properties":{"id":{"$ref":"#/components/schemas/PermissionId"},"action":{"$ref":"#/components/schemas/PermissionAction"},"scope":{"$ref":"#/components/schemas/PermissionScope"},"source":{"$ref":"#/components/schemas/App"},"target":{"$ref":"#/components/schemas/Account"},"created":{"$ref":"#/components/schemas/Created"}},"required":["id","action","scope","source","target","created"],"additionalProperties":false,"$id":"./components/schemas/Permission","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/Permission","description":"Documentation"}},"PermissionArray":{"title":"Permission Array","type":"array","items":{"$ref":"#/components/schemas/Permission"},"$id":"./components/schemas/PermissionArray","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/PermissionArray","description":"Documentation"}},"ProductArray":{"title":"Product Array","type":"array","items":{"$ref":"#/components/schemas/Product"},"$id":"./components/schemas/ProductArray","externalDocs":{"url":"https://developer.hedia.com/services/licensing/management/api/v1/components/schemas/ProductArray","description":"Documentation"}}},"parameters":{"SkipQueryParameter":{"name":"skip","in":"query","required":false,"schema":{"$ref":"#/components/schemas/Skip"}},"LimitQueryParameter":{"name":"limit","in":"query","required":false,"schema":{"$ref":"#/components/schemas/Limit"}},"CustomerCodeQueryParameter":{"name":"code","in":"query","required":false,"description":"Filter customers by code.","schema":{"$ref":"#/components/schemas/CustomerCode"}},"CustomerIdQueryParameter":{"name":"customerId","in":"query","required":false,"description":"Filter licenses by customer ID.","schema":{"$ref":"#/components/schemas/CustomerId"}},"LicenseIdPathParameter":{"name":"licenseId","in":"path","required":true,"schema":{"$ref":"#/components/schemas/LicenseId"}},"ProductCodeQueryParameter":{"name":"code","in":"query","required":false,"description":"Filter products by code.","schema":{"$ref":"#/components/schemas/ProductCode"}}},"responses":{"InternalServerError":{"description":"Internal Server Error","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorProblem"}}}},"Unauthorized":{"description":"Unauthorized","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnauthorizedProblem"}}}},"Forbidden":{"description":"Forbidden","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/InternalServerErrorProblem"}}}},"NotFound":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/OperationNotFoundProblem"}}}},"SignalAborted":{"description":"Signal Aborted","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/SignalAbortedProblem"}}}},"UnsupportedMediaType":{"description":"Unsupported Media Type","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/UnsupportedMediaTypeProblem"}},"text/html":{"schema":{"$ref":"#/components/schemas/Html"}}}},"NoContent":{"description":"No content"}}},"externalDocs":{"url":"https://developer.hedia.com/","description":"Documentation"}}